#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  char myname[MPI_MAX_PROCESSOR_NAME]; 
  int size, rank, rlen, N;
  MPI_Status status;

  /* MPI inizializza mpi
   */

  if (rank == 0) {
    if (argc == 2) {
      N = atoi (argv[1]);
      if (N < 0)
        N = 10;
    }
    else 
      N = 10;
  }

  fprintf (stdout, "I am proces %3d of %3d my name is %s (%s)\n", 
    rank, size, myname, argv[0]);

  fflush(stdout);

  if (size > 1) {
    if (rank == 0) {
      int val = N;
    
      do {
        fprintf (stdout, "  Ring value %d\n", val);
        /* MPI zero spedisce a 1 
         * MPI zero riceve da size-1
         */
        val--;
      } while (val >= 0);
    
      fprintf (stdout, "Ring stop %d\n", val);
    }
    else {
      int val;
    
      do {
        /* MPI riceve da rank-1 */
        if (rank == (size-1))
          /* MPI spedisce a 0 */
        else
          /* MPI spedisce a rank + 1 */
      } while (val > 0);
    }
  }

  /* MPI finilize */
 
  return 0;
} 
